%define with_hamcrest 0
%define with_maven 1
Name:          concurrentlinkedhashmap-lru
Version:       1.2
Release:       %mkrel 1
Summary:       A ConcurrentLinkedHashMap for Java
Group:         Development/Java
License:       ASL 2,0
Url:           http://code.google.com/p/concurrentlinkedhashmap/
# svn export http://concurrentlinkedhashmap.googlecode.com/svn/tags/concurrentlinkedhashmap-lru-1.1
# tar czf concurrentlinkedhashmap-lru-1.1-src-svn.tar.gz concurrentlinkedhashmap-lru-1.1
Source0:       concurrentlinkedhashmap-lru-%{version}-src-svn.tar.gz
# org.jvnet.wagon-svn wagon-svn
Patch0:        concurrentlinkedhashmap-lru-1.1-remove-wagon-svn.patch
# requires: hamcrest >= 1.3rc1
Patch1:        concurrentlinkedhashmap-lru-1.2-remove-hamcrest.patch

BuildRequires: jpackage-utils
BuildRequires: java-devel
BuildRequires: sonatype-oss-parent

# TODO benchmark-fwk.jar
#BuildRequires: apache-commons-beanutils
#BuildRequires: apache-commons-digester
#BuildRequires: jcommon
#BuildRequires: jfreechart
#BuildRequires: liblog4j-java

%if %with_hamcrest
BuildRequires: hamcrest >= 1.3
%endif

BuildRequires: apache-commons-collections
BuildRequires: apache-commons-lang
BuildRequires: apache-commons-logging
BuildRequires: apache-commons-math
BuildRequires: caliper
BuildRequires: colt
BuildRequires: concurrent
BuildRequires: ehcache-core
BuildRequires: ehcache-parent
BuildRequires: guava09
BuildRequires: jaxen
BuildRequires: mockito
BuildRequires: objectweb-asm
BuildRequires: pmd
BuildRequires: slf4j
BuildRequires: testng >= 5.12
BuildRequires: forge-parent
%if !%with_maven
BuildRequires: ant
%else
BuildRequires: maven
BuildRequires: maven-compiler-plugin
BuildRequires: maven-install-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: maven-surefire-provider-testng
BuildRequires: properties-maven-plugin
BuildRequires: maven-enforcer-plugin
%endif


Requires:      jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:      java
BuildArch:     noarch

%description
A high performance version of java.util.LinkedHashMap for use as a software cache.
Features:

* LRU page replacement policy (currently being upgraded to LIRS).
* Equivalent performance to ConcurrentHashMap under load.
* Can bound by the size of the values (e.g. Multimap cache).
* Can notify a listener when an entry is evicted. 

%package javadoc
Summary:       Javadocs for %{name}
Group:         Development/Java
Requires:      jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q

rm -rf $(find . -name "*.jar")
rm -rf $(find . -name "*.class")
#for j in $(find . -name "*.jar"); do
#  mv $j $j.no
#done

%patch0 -p0
# TODO
%if %with_hamcrest
%if !%with_maven
ln -sf $(build-classpath hamcrest/all) lib/hamcrest/1.3.0rc1/hamcrest-all.jar
%endif
%else
%patch1 -p0
rm -rf unittest/src/java/com/googlecode/concurrentlinkedhashmap/*.java
%endif

%if !%with_maven

# TODO
#mv lib/cache-benchmark/r7903/benchmark-fwk.jar.no lib/cache-benchmark/r7903/benchmark-fwk.jar
#ln -sf $(build-classpath commons-beanutils) lib/cache-benchmark/r7903/commons-beanutils.jar
#ln -sf $(build-classpath commons-digester) lib/cache-benchmark/r7903/commons-digester.jar
#ln -sf $(build-classpath commons-logging) lib/cache-benchmark/r7903/commons-logging.jar
#ln -sf $(build-classpath commons-math) lib/cache-benchmark/r7903/commons-math-1.0.jar
#ln -sf $(build-classpath jcommon) lib/cache-benchmark/r7903/jcommon.jar
#ln -sf $(build-classpath jfreechart/jfreechart) lib/cache-benchmark/r7903/jfreechart.jar
#ln -sf $(build-classpath log4j) lib/cache-benchmark/r7903/log4j.jar
rm -rf benchmark/src/java/org/cachebench/cachewrappers/*.java

ln -sf $(build-classpath caliper) lib/caliper/0.0/caliper.jar
ln -sf $(build-classpath guava) lib/guava/r07/guava-r07.jar
ln -sf $(build-classpath commons-collections) lib/commons-collections/3.2.1/commons-collections-3.2.1.jar
ln -sf $(build-classpath commons-lang) lib/commons-lang/2.5/commons-lang-2.5.jar
ln -sf $(build-classpath commons-math) lib/commons-math/2.1/commons-math-2.1.jar

ln -sf $(build-classpath colt) lib/colt/1.2.0/colt.jar
ln -sf $(build-classpath concurrent) lib/colt/1.2.0/concurrent.jar
ln -sf $(build-classpath ehcache-core) lib/ehcache/2.0.1/ehcache-core-2.0.1.jar
ln -sf $(build-classpath slf4j/api) lib/ehcache/2.0.1/lib/slf4j-api-1.5.8.jar
ln -sf $(build-classpath slf4j/jdk14) lib/ehcache/2.0.1/lib/slf4j-jdk14-1.5.8.jar
ln -sf $(build-classpath testng) lib/testng/5.12/testng-5.12.jar
ln -sf $(build-classpath pmd) lib/pmd/4.2.5/pmd-4.2.5.jar
ln -sf $(build-classpath objectweb-asm/asm-all) lib/pmd/4.2.5/asm-3.1.jar
ln -sf $(build-classpath jaxen) lib/pmd/4.2.5/jaxen-1.1.1.jar

#ln -sf $(build-classpath cobertura) lib/cobertura/1.9.4.1/cobertura.jar
#ln -sf $(build-classpath objectweb-asm/asm) lib/cobertura/1.9.4.1/lib/asm-3.0.jar
#ln -sf $(build-classpath objectweb-asm/asm-tree) lib/cobertura/1.9.4.1/lib/asm-tree-3.0.jar
#ln -sf $(build-classpath oro) lib/cobertura/1.9.4.1/lib/jakarta-oro-2.0.8.jar
#ln -sf $(build-classpath log4j) lib/cobertura/1.9.4.1/lib/log4j-1.2.9.jar

%endif

%build

%if !%with_maven
  ant package document
%else
  mvn-rpmbuild install javadoc:aggregate
%endif

%install

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -pm 644 build/%{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar

install -d -m 755 $RPM_BUILD_ROOT%{_mavenpomdir}
install -pm 644 pom.xml $RPM_BUILD_ROOT%{_mavenpomdir}/JPP-%{name}.pom
%add_to_maven_depmap com.googlecode.concurrentlinkedhashmap %{name} %{version} JPP %{name}

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}
cp -rp build/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%files
%{_javadir}/%{name}.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%{_javadocdir}/%{name}


%changelog

* Sun Mar 04 2012 gil <gil> 1.2-1.mga2
+ Revision: 218261
- update to 1.2

* Thu Nov 10 2011 gil <gil> 1.1-1.mga2
+ Revision: 166130
- imported package concurrentlinkedhashmap-lru

